;
;   0-22,5  (0,1 )
;     2,25 A (0,01 A)
;     VAMPER.ASM
;    MPLAB IDE 5.70.40.
;       
;      20.05.2009
;
	LIST P=16F73
            #INCLUDE <P16F73.INC>
            __CONFIG 3FE9H
;+++++++
RI		EQU .120 ;  , 
N		EQU -.5000/RI
;+++++++
;====================================================
;    4,0 M.
;====================================================
;   - 
;  B - 
; RA0 -   .
; RA1 -   .
;===========================================
;   
;===========================================
SEG	EQU 21H		; .
TEKI	EQU 22H		; 
TEKU	EQU 23H		;
;+++++++
DU		EQU 24H ;     
;+++++++
ANOD	EQU 27H		;
ANOD2	EQU 28H		;  
ULED0	EQU 2BH		;  , 0.
ULED1	EQU 2CH		;1.
ULED2	EQU 2DH		;2.
ULED3	EQU 2EH		;3
ILED0   EQU 30H		;  , 0,
ILED1   EQU 31H		;1.
ILED2   EQU 32H		;2.
ILED3	EQU 33H		;3
COUNT	EQU 34H		;  
COUN	EQU 36H		; 
ZPT	EQU 37H		;
;=======================
; 1. 
;=======================
	ORG     0
        GOTO   INIT
;=======================================
; 2.      
;=======================================
SEGDATA                      ;7, 6, 5, 4, 3, 2, 1, 0.  
         ADDWF   PCL,F       ;H, G, F, E, D, C, B, A.  

         RETLW   B'00111111' ; 0 
         RETLW   B'00000110' ; 1 
         RETLW   B'01011011' ; 2 
         RETLW   B'01001111' ; 3 
         RETLW   B'01100110' ; 4 
         RETLW   B'01101101' ; 5 
         RETLW   B'01111101' ; 6 
         RETLW   B'00000111' ; 7 
         RETLW   B'01111111' ; 8 
         RETLW   B'01101111' ; 9
	 RETLW	 B'00011100' ; 10  U
	 RETLW	 B'00000100' ; 11  I

;==============================
; 3. .
;==============================
IND
	MOVLW	.80		;-  
	MOVWF	COUNT		; 
IND8	MOVLW	.254		;  
	MOVWF	ANOD		;
	CLRF	ANOD2		;
IND0

	MOVLW	.11		; 
	MOVWF	ILED0          	;  
	MOVFW	ILED0		; 
	CALL	INDZ		;
	CALL	DELAY           ;.
IND1
	MOVFW	 ILED1         	;ILED1  
	CALL	 INDZ		;
	CALL	 DELAY          ;.
IND2
	MOVFW	 ILED2         	;
	CALL	 INDZ		;
	CALL	 DELAY          ;.
IND3
	MOVLW	 .3		;  
	MOVWF	 ZPT		; 
	MOVFW	 ILED3		;
	CALL	 INDZ		;
	CALL	 DELAY          ;.
IND4
	MOVLW	.10		; 
	MOVWF	ULED0		;  
	MOVFW	ULED0		; 
	CALL	INDZ		;
	CALL	DELAY           ;.
IND5
	MOVFW	ULED1		;
	CALL	INDZ		;.
	CALL	DELAY           ;.
IND6
	MOVLW	.6		; 
	MOVWF	ZPT		; 
	MOVFW	ULED2		;
	CALL	INDZ		;
	CALL	DELAY           ;.
IND7
	MOVFW	ULED3		;
	CALL	INDZ		;
	CALL	DELAY   	;

	DECFSZ	COUNT,f		;    
	GOTO	IND8		;    
	GOTO	MEASURE		;  - 
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
INDZ
	CALL	SEGDATA		; 
	MOVWF	SEG		; .
	MOVFW	ZPT		;    
	SUBWF	ANOD2,0		;  
	SKPNZ			;  
	BSF	SEG,7		; 
	MOVFW	SEG		; 
	MOVWF	PORTB		;  B.
	MOVFW	ANOD		; .
	MOVWF	PORTC		;  .

	BSF	STATUS,0	;
	RLF	ANOD,1		;
	INCF	ANOD2,1		;  
	RETURN			;
DELAY           
	MOVLW	.250		;-  
	MOVWF	COUN		;
	DECFSZ	COUN,1		;
	GOTO	$-1		;
	RETURN			;

;===================================================
; 4.  
;===================================================
MEASURE
				; 
	BSF	STATUS,5	;  1.   .
	MOVLW	B'10000100'	;
	MOVWF	ADCON1^80H      ;
	BCF	STATUS,5	; 0.
        MOVLW	B'11001001'	;  RC
        MOVWF	ADCON0		;  
	CALL	DELAY05		;.
	BCF	INTCON,7	; .
        BSF	ADCON0,2	;.
        BTFSC	ADCON0,2	; 
        GOTO	$-1          	;.
        MOVFW	ADRES       	; 
        MOVWF	TEKI		;  .
	BSF	INTCON,7	; .
;+++++++  
	clrf	DU
	movf	TEKI,W
L1	incf	DU,F
	addlw	N
	btfsc	STATUS, C
	goto	L1
	;decf	DU,F
	rrf	DU, f
;+++++++
HUNDI				;
	CLRF	ILED3
	MOVF	TEKI,W
LOOP1I
	INCF	ILED3,F
	ADDLW	-D'100'
	BTFSC	STATUS,C
	GOTO	LOOP1I
	DECF	ILED3,F
	ADDLW	D'100'
	MOVWF	TEKI
DECI
	CLRF	ILED2
	MOVF	TEKI,W
LOOPI
	INCF	ILED2,F
	ADDLW	-D'10'
	BTFSC	STATUS,C
	GOTO	LOOPI
	DECF	ILED2,F
	ADDLW	D'10'
	MOVWF	ILED1
	
				; 
	NOP
	BSF	STATUS,5	;  1.   .
	MOVLW	B'10000100'	;
	MOVWF	ADCON1^80H      ;
	BCF	STATUS,5	; 0.
        MOVLW	B'11000001'	;  RC
        MOVWF	ADCON0		;  
	CALL	DELAY05		;.
	BCF	INTCON,7	; .
        BSF	ADCON0,2	;.
        BTFSC	ADCON0,2	; 
        GOTO	$-1          	;.
        MOVFW	ADRES       	; 
        MOVWF	TEKU		;  .
	BSF	INTCON,7	; .
;+++++++  
        movf	DU,W
	subwf	TEKU,w
	btfsc	STATUS,C
	movwf	TEKU
;+++++++
HUNDU				;
	CLRF	ULED3
	MOVF	TEKU,W
LOOP1U
	INCF	ULED3,F
	ADDLW	-D'100'
	BTFSC	STATUS,C
	GOTO	LOOP1U
	DECF	ULED3,F
	ADDLW	D'100'
	MOVWF	TEKU

DECU
	CLRF	ULED2
	MOVF	TEKU,W
LOOPU
	INCF	ULED2,F
	ADDLW	-D'10'
	BTFSC	STATUS,C
	GOTO	LOOPU
	DECF	ULED2,F
	ADDLW	D'10'
	MOVWF	ULED1
	
	GOTO	IND			

DELAY05
	MOVLW	.5		
	ADDLW	-1		
	BTFSS	STATUS,2	
	GOTO	$-2		

      RETURN
;===========================================================
; 5. .
;===========================================================
INIT
 BSF		STATUS,RP0       ; 1.
 MOVLW 		B'00000000'      ;   
 MOVWF		INTCON           ;
 MOVLW		B'10000100'	 ; 
 MOVWF		ADCON1^80H       ;
 MOVLW 		B'00111011'      ; TRIS
 MOVWF 		TRISA^80H        ;
 CLRF  		TRISB^80H        ;
 CLRF  		TRISC^80H        ;
 BCF   		STATUS,RP0       ; 0.
 CLRF  		PORTA            ;
 CLRF 		PORTB            ;
 CLRF 		PORTC            ;
 CLRF  		T1CON            ; 1  2 
 CLRF 		T2CON            ;
 CLRF  		ULED0
 CLRF  		ULED1
 CLRF 		ULED2
 CLRF 		ULED3
 CLRF   	ILED0          
 CLRF   	ILED1         
 CLRF   	ILED2
 CLRF		ILED3         
 GOTO   	IND		; 

;=========================================== 
   END
;===========================================

